package bucket

import (
	"errors"
	"fmt"
)

type Bucket string

const bucketMetadataObject = "metadata.json"

var ErrorInvalidBucket = errors.New("invalid bucket")

func (b Bucket) Validate() error {
	if len(b) < 1 || b == "meta" {
		return fmt.Errorf("%w: %v", ErrorInvalidBucket, b)
	}
	return nil
}

func (b Bucket) String() string {
	return string(b)
}

type BucketMetadata struct {
	Title          string          `json:"title"`
	PreviewOptions []PreviewOption `json:"preview_options"`
}
