package bucket

import (
	"errors"
	"fmt"
	"strings"
)

type Photo string

const photoPrefix = "photo/"

var ErrorInvalidPhoto = errors.New("invalid photo")

func (p Photo) Validate() error {
	if !strings.HasPrefix(string(p), photoPrefix) {
		return fmt.Errorf("%w: %v", ErrorInvalidPhoto, p)
	}
	return nil
}

func (p Photo) String() string {
	return string(p)
}

func (p Photo) Path() string {
	return "/" + string(p)
}
